import _extends from 'babel-runtime/helpers/extends';
import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import React, { PureComponent } from 'react';
import PropTypes from 'prop-types';
import { FormModel } from '../Form/FormModel';
import { FormItemModel } from '../Form/FormItemModel';
import { FieldErrorsComponent } from './FieldErrorsComponent';

var FieldErrors = function (_PureComponent) {
  _inherits(FieldErrors, _PureComponent);

  function FieldErrors(props, context) {
    _classCallCheck(this, FieldErrors);

    var _this = _possibleConstructorReturn(this, _PureComponent.call(this, props, context));

    _this.formModel = context.formModel;
    _this.formItemModel = context.formItemModel;
    return _this;
  }

  FieldErrors.prototype.componentDidMount = function componentDidMount() {
    var _this2 = this;

    this.subscriberId = this.formModel.addSubscriber(function () {
      _this2.forceUpdate();
    });
  };

  FieldErrors.prototype.componentWillUnmount = function componentWillUnmount() {
    this.formModel.removeSubscriber(this.subscriberId);
  };

  FieldErrors.prototype.render = function render() {
    if (this.formModel.initialized) {
      var _props = this.props,
          name = _props.name,
          component = _props.component,
          other = _objectWithoutProperties(_props, ['name', 'component']);

      var field = null;
      if (this.formItemModel) {
        field = this.formItemModel.fields.field(name);
      } else {
        field = this.formModel.fields.field(name);
      }
      return React.createElement(component, _extends({
        form: this.formModel.getPublic(),
        formItem: this.formItemModel && this.formItemModel.getPublic(),
        field: field && field.getPublic()
      }, other));
    }
    return null;
  };

  return FieldErrors;
}(PureComponent);

FieldErrors.propTypes = {
  name: PropTypes.string,
  component: PropTypes.func
};
FieldErrors.defaultProps = {
  name: '',
  component: FieldErrorsComponent
};
FieldErrors.contextTypes = {
  formModel: PropTypes.instanceOf(FormModel).isRequired,
  formItemModel: PropTypes.instanceOf(FormItemModel)
};


export { FieldErrors };