import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import React, { Component } from 'react';
import PropTypes from 'prop-types';

var FieldErrorsComponent = function (_Component) {
  _inherits(FieldErrorsComponent, _Component);

  function FieldErrorsComponent() {
    _classCallCheck(this, FieldErrorsComponent);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  FieldErrorsComponent.prototype.render = function render() {
    var _props = this.props,
        form = _props.form,
        field = _props.field;

    var errors = [];
    var invalid = false;
    if (field) {
      errors = field.errors();
      invalid = field.touched && !field.isValid();
    } else {
      errors = form.errors().form;
      invalid = form.isTouched() && errors.length;
    }
    return React.createElement(
      'div',
      null,
      invalid && errors.map(function (error) {
        return React.createElement(
          'div',
          { key: error },
          error
        );
      })
    );
  };

  return FieldErrorsComponent;
}(Component);

FieldErrorsComponent.propTypes = {
  form: PropTypes.object.isRequired,
  field: PropTypes.object
};
FieldErrorsComponent.defaultProps = {
  field: null
};


export { FieldErrorsComponent };