'use strict';

exports.__esModule = true;
exports.connectForm = exports.FormModel = exports.VBForm = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _FormModel = require('./FormModel');

var _FormItem = require('./FormItem');

var _FormField = require('../FormField');

var _decorator = require('./decorator');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var VBForm = function (_React$PureComponent) {
  (0, _inherits3.default)(VBForm, _React$PureComponent);

  function VBForm(props) {
    (0, _classCallCheck3.default)(this, VBForm);

    var _this = (0, _possibleConstructorReturn3.default)(this, _React$PureComponent.call(this, props));

    _this.onSubmit = function () {
      return _this.__onSubmit__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.model = new _FormModel.FormModel(props.name, props.validator, props.onChangeForm);
    return _this;
  }

  VBForm.prototype.__onSubmit__REACT_HOT_LOADER__ = function __onSubmit__REACT_HOT_LOADER__() {
    return this.__onSubmit__REACT_HOT_LOADER__.apply(this, arguments);
  };

  VBForm.prototype.getChildContext = function getChildContext() {
    return { formModel: this.model };
  };

  VBForm.prototype.componentDidMount = function componentDidMount() {
    this.model.validate();
    this.model.completed();
    this.props.onLoadForm(this.model.getPublic());
  };

  VBForm.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {};

  VBForm.prototype.componentDidUpdate = function componentDidUpdate() {};

  VBForm.prototype.componentWillUnmount = function componentWillUnmount() {
    this.model.willDelete();
  };

  VBForm.prototype.__onSubmit__REACT_HOT_LOADER__ = function __onSubmit__REACT_HOT_LOADER__(e) {
    e.preventDefault();
    if (this.model.isValid()) {
      this.model.makeSubmitted();
      this.props.onSubmit(this.model.values(), this.model.getPublic());
    }
  };

  VBForm.prototype.render = function render() {
    var _props = this.props,
        children = _props.children,
        onSubmit = _props.onSubmit,
        onChangeForm = _props.onChangeForm,
        onLoadForm = _props.onLoadForm,
        validator = _props.validator,
        other = (0, _objectWithoutProperties3.default)(_props, ['children', 'onSubmit', 'onChangeForm', 'onLoadForm', 'validator']);

    return _react2.default.createElement(
      'form',
      (0, _extends3.default)({ onSubmit: this.onSubmit }, other),
      children
    );
  };

  return VBForm;
}(_react2.default.PureComponent);

VBForm.propTypes = {
  name: _propTypes2.default.string,
  validator: _propTypes2.default.func,
  children: _propTypes2.default.any.isRequired,
  onLoadForm: _propTypes2.default.func,
  onChangeForm: _propTypes2.default.func,
  onSubmit: _propTypes2.default.func
};
VBForm.defaultProps = {
  name: null,
  validator: function validator() {
    return {};
  },
  onLoadForm: function onLoadForm() {},
  onChangeForm: function onChangeForm() {},
  onSubmit: function onSubmit() {}
};
VBForm.childContextTypes = {
  formModel: _propTypes2.default.instanceOf(_FormModel.FormModel).isRequired
};


VBForm.Field = _FormField.FormField;
VBForm.Errors = _FormField.FieldErrors;
VBForm.Item = _FormItem.FormItem;

exports.VBForm = VBForm;
exports.FormModel = _FormModel.FormModel;
exports.connectForm = _decorator.connectForm;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(VBForm, 'VBForm', 'E:/Projects/React/git/vb-react-form/src/FormsV1/Form/index.js');
}();

;