'use strict';

exports.__esModule = true;
exports.maxLengthValidator = exports.minLengthValidator = exports.passwordValidator = exports.regexValidator = exports.equalValidator = exports.emailValidator = exports.requiredValidator = exports.validators = undefined;

var _validators = require('./validators');

var requiredValidator = function requiredValidator() {
  var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

  var errors = [];
  if (!_validators.validators.required.check(value)) {
    errors.push(_validators.validators.required.message);
  }
  return errors;
};

var emailValidator = function emailValidator() {
  var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

  var errors = [];
  if (!_validators.validators.email.check(value)) {
    errors.push(_validators.validators.email.message);
  }
  return errors;
};

var equalValidator = function equalValidator() {
  var value1 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var value2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

  var errors = [];
  if (!_validators.validators.equal.check(value1, value2)) {
    errors.push(_validators.validators.equal.message);
  }
  return errors;
};

var regexValidator = function regexValidator() {
  var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var regex = arguments[1];

  var errors = [];
  if (!_validators.validators.regex.check(regex, value)) {
    errors.push(_validators.validators.regex.message);
  }
  return errors;
};

var passwordValidator = function passwordValidator() {
  var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

  var errors = [];
  if (!_validators.validators.password.check(value)) {
    errors.push(_validators.validators.password.message);
  }
  return errors;
};

var minLengthValidator = function minLengthValidator() {
  var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var len = arguments[1];

  var errors = [];
  if (!_validators.validators.minLength.check(value, len)) {
    errors.push(_validators.validators.minLength.message(len));
  }
  return errors;
};

var maxLengthValidator = function maxLengthValidator() {
  var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var len = arguments[1];

  var errors = [];
  if (!_validators.validators.maxLength.check(value, len)) {
    errors.push(_validators.validators.maxLength.message(len));
  }
  return errors;
};

exports.validators = _validators.validators;
exports.requiredValidator = requiredValidator;
exports.emailValidator = emailValidator;
exports.equalValidator = equalValidator;
exports.regexValidator = regexValidator;
exports.passwordValidator = passwordValidator;
exports.minLengthValidator = minLengthValidator;
exports.maxLengthValidator = maxLengthValidator;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(requiredValidator, 'requiredValidator', 'E:/Projects/React/git/vb-react-form/src/FormsV1/Validators/index.js');

  __REACT_HOT_LOADER__.register(emailValidator, 'emailValidator', 'E:/Projects/React/git/vb-react-form/src/FormsV1/Validators/index.js');

  __REACT_HOT_LOADER__.register(equalValidator, 'equalValidator', 'E:/Projects/React/git/vb-react-form/src/FormsV1/Validators/index.js');

  __REACT_HOT_LOADER__.register(regexValidator, 'regexValidator', 'E:/Projects/React/git/vb-react-form/src/FormsV1/Validators/index.js');

  __REACT_HOT_LOADER__.register(passwordValidator, 'passwordValidator', 'E:/Projects/React/git/vb-react-form/src/FormsV1/Validators/index.js');

  __REACT_HOT_LOADER__.register(minLengthValidator, 'minLengthValidator', 'E:/Projects/React/git/vb-react-form/src/FormsV1/Validators/index.js');

  __REACT_HOT_LOADER__.register(maxLengthValidator, 'maxLengthValidator', 'E:/Projects/React/git/vb-react-form/src/FormsV1/Validators/index.js');
}();

;